Notes on the documentation

This description is only intended for the use of trained specialists in control and automation engineering who are familiar with the applicable national standards.
It is essential that the following notes and explanations are followed when installing and commissioning these components.

The responsible staff must ensure that the application or use of the products described satisfy all the requirements for safety, including all the relevant laws, regulations, guidelines and standards.

Disclaimer

The documentation has been prepared with care. The products described are, however, constantly under development.
For that reason the documentation is not in every case checked for consistency with performance data, standards or other characteristics.
In the event that it contains technical or editorial errors, we retain the right to make alterations at any time and without warning.
No claims for the modification of products that have already been supplied may be made on the basis of the data, diagrams and descriptions in this documentation.

Trademarks

Beckhoff®, TwinCAT®, EtherCAT®, Safety over EtherCAT®, TwinSAFE® and XFC® are registered trademarks of and licensed by Beckhoff Automation GmbH.
Other designations used in this publication may be trademarks whose use by third parties for their own purposes could violate the rights of the owners.

Patent Pending

The TwinCAT Technology is covered, including but not limited to the following patent applications and patents:
EP0851348, US6167425 with corresponding applications or registrations in various other countries.

Copyright

© Beckhoff Automation GmbH & Co. KG, Germany.
The reproduction, distribution and utilization of this document as well as the communication of its contents to others without express authorization are prohibited.
Offenders will be held liable for the payment of damages. All rights reserved in the event of the grant of a patent, utility model or design.


Required Installations

Installing TwinCAT

Please refer to the appropriate TwinCAT documentation for details of its installation

Installing the SST Programs

The installation versions of the SST device driver for the 5136-CN PC card (DeviceDriver directory) and of the SST configuration tool (ConfigTool directory) are located in the Unsupported Utilities/Sst directory. Use the following procedure for installation:

Installing the SST Device Driver

Run the setup program from the Unsupported Utilities/Sst/DeviceDriver directory, and follow the instructions given by the program.

Installing the SST Configuration Tool

Run the setup program from the Unsupported Utilities/Sst/ConfigTool directory, and follow the instructions given by the program.

Performing the 5136-CN Hardware Settings (not necessary for the 5136-CN PCI)

Run the SST Card Configuration program, found under Programs->SST Card Config. Normally a window will appear with two default entries:

One entry should be deleted (using the Remove button), and the other should be edited (using Properties). A new dialog appears in which the I/O address of the 5136-CN is to be set in accordance with the DIP switch and where the memory address and the name can be adjusted.

Linking the EDS Files to the SST Configuration Tool

The program "CN Config Tool", found under "Programs->SST CN", should be run. If a BK7000 is to be used, the EDS file for the BK7000 (BK7000B8.eds, found under EDS Files on the CD) should be copied to the "Programs/SST/CN/CN Config Tool/EDS" directory.

EDS files can be added to the EDS library by means of the Add icon (on the far left).

A file selection dialog appears in which it is best to select all the files.

The EDS library is then loaded, and projects can be created.


Install/uninstall TcSstCN Com Server

Installing

It is necessary under TwinCAT 2.7 for the TcSstCN-COM server to be manually registered. To do this, the file TcSstCN\TcSstCN.exe must first be copied from the CD into the WINNT/system32 directory. The server must then be registered (choose Start->Run, type TcSstCN /TcServer into the command box, then press OK).

Removing

In order to uninstall the TcSstCN-COM server it is again necessary to select "Start->Run". Then type in TcSstCN /UnRegServer, and press OK. The server is then removed from the system.


Overview

The ControlNet configuration must be generated using the SST-Configuration-Tool.

The program "CN Config Tool" under "Programs->SST CN" is called for this purpose.

The 5136-CN PC card is first entered as the scanner. This is achieved by clicking on "The Network (Network Configuration)" with the right mouse button, and selecting "New Scanner".

The new scanner then appears in the right hand window:

The scanner's properties can be set by double-clicking on it. As a rule, only the card concerned has to be entered under "Card Name", along with the Mac-ID if appropriate.

ControlNet devices can now be dragged to the scanner from the EDS library using the left mouse button.


BK7000 Configuration

The BK7000 is found in the EDS library under the entry "Unknown Device ID: 128". The BK7000 is dragged with the left mouse button out of the EDS library to the scanner in the right hand window. It will then appear in the right hand window. The properties of the BK7000 can be set by double-clicking on it in the right hand window.

The "O=>T Size" (the length of the output in words) and the "T=>O Size" (the length of the input in words + 2) are to be set in the dialog in accordance with the terminal configuration. In order to calculate the output and input lengths, the BK7000 supports four mapping schemes, which are set automatically in accordance with the selected size:

Compact mapping: A KL3xx2 requires 4 input bytes, a KL3xx4 requires 8 input bytes, a KL4xx2 requires 4 output bytes, a KL4xx4 requires 8 output bytes, a KL1501 requires 5 input and output bytes, a KL5001 requires 4 input bytes, a KL2502 or KL51x1 requires 6 input and output bytes, a KL6xx1 requires 4 input and output bytes in alternative format and 6 input and output bytes in standard format. For digital terminals, only the total is calculated and rounded up for word alignment

Compact mapping wit WORD alignment: A KL3xx2 requires 4 input bytes, a KL3xx4 requires 8 input bytes, a KL4xx2 requires 4 output bytes, a KL4xx4 requires 8 output bytes, a KL1501 requires 6 input and output bytes, a KL5001 requires 4 input bytes, a KL2502 and KL51x1 requires 8 input and output bytes, a KL6xx1 requires 4 input and output bytes in alternative format and 6 input and output bytes in standard format. For digital terminals, only the total is calculated and rounded up for word alignment

Complex mapping: A KL3xx2 requires 6 input and output bytes, a KL3xx4 requires 12 input and output bytes, a KL4xx2 requires 6 input and output bytes, a KL4xx4 requires 12 input and output bytes, a KL1501 requires 5 input and output bytes, a KL5001 requires 5 input and output bytes, a KL2502 or KL51x1 requires 6 input and output bytes, a KL6xx1 requires 6 input and output bytes in alternative format and 6 input and output bytes in standard format. For digital terminals, only the total is calculated and rounded up for word alignment

Complex mapping wit WORD alignment: A KL3xx2 requires 8 input and output bytes, a KL3xx4 requires 16 input and output bytes, a KL4xx2 requires 8 input and output bytes, a KL4xx4 requires 16 input and output bytes, a KL1501 requires 6 input and output bytes, a KL5001 requires 6 input and output bytes, a KL2502 or KL51x1 requires 6 input and output bytes, a KL6xx1 requires 8 input and output bytes in alternative format and 6 input and output bytes in standard format. For digital terminals, only the total is calculated and rounded up for word alignment

It may also be necessary for the Mac-ID and the "O=>T RPI" or the "T=>O RPI" to be set (these values must be greater than or equal to the network settings for the NUT interval).


AB Flex I/O Device Configuration

First of all, a "Flex 8 Slot Chassis" must be dragged with the left mouse button from the EDS library's "Chassis" entry to the scanner in the right hand window. The AB Flex I/O chassis then appears in the right hand window.

Next, the corresponding Flex I/O adapter is to be dragged with the left mouse button from the EDS library's "Communication Adapter" entry, across to the chassis in the right hand window - a field appears with 0 for the slot number, which is to be selected. The Flex-I/O adapter then appears in the right hand window.

It is finally necessary for the appropriate modules for the Flex-I/O device to be added by dragging them with the left mouse button from the "General Purpose Analog IO" or "General Purpose Digital IO" entries, across to the chassis in the right hand window. A field with the slot number, which has to be selected, appears.

The Mac-ID can be set in the dialog which appears by double-clicking the chassis.

Double-clicking the Flex I/O adapter allows the "O=>T RPI" or "T=>O RPI" values to be set. These values must be greater than or equal to the network settings for the NUT interval.


PLC 5 Configuration

The appropriate PLC 5 is to be dragged with the left mouse button from the "Programmable Logic Controller" entry across to the scanner in the right hand window. The PLC5 then appears in the right hand window.

A double-click on the PLC 5 will bring up a dialog in which the "T=>O Size" (inputs, PLC 5 send data) in Words and, when appropriate, the Mac-ID and the "O=>T RPI" or the "T=>O RPI" can be set. These values must be greater than or equal to the network settings for the NUT interval.

It is also possible for the Consume Buffer-ID to be set, under parameters. This must agree with the Produce Buffer ID set in the PLC 5.

The outputs (PLC 5 receive data) are added by dragging a 5136-CN send adapter from the "Communication Adapter" entry in the EDS library across to the scanner with the left mouse button.

Double-clicking on the send connection that has been inserted brings up a dialog in which the T=>O Size (outputs, PLC 5 receive data), is set.

It is also possible for the Produce Buffer ID to be set, under parameters. This must agree with the Consume Buffer ID set in the PLC 5. This Produce Buffer ID is also used for addressing the process data from TwinCAT (-> Process data send connection)

Please refer to the PDF file sstcn_schplc5.pdf for the settings in RS Networx.


ControlLogix Configuration

The appropriate Control-Logix chassis is to be selected and dragged with the left mouse button from the "Chassis" entry across to the scanner in the right hand window. The Control-Logix chassis then appears in the right hand window.

The appropriate Control-Logix CPU is to be dragged with the left mouse button from the "Programmable Logic Controller" entry across to the chassis in the right hand window. The slot number of the CPU (not of the ControlNet interface) has to be selected here. The Control-Logix CPU then appears in the right hand window.

A double-click on the Control-Logix CPU will bring up a dialog in which the "T=>O Size" (inputs, Control-Logix send data (Producer must be clicked on the corresponding tag)) in Words and, when appropriate, the Mac-ID and the "O=>T RPI" or the "T=>O RPI" can be set. These values must be greater than or equal to the network settings for the NUT interval.

Under the "Control Logix Tag Name" button it is still necessary for the tag name of the corresponding Control-Logix output tag to be stated.

The outputs (Control-Logix receive data) are added by dragging a 5136-CN send adapter from the "Communication Adapter" entry in the EDS library across to the scanner with the left mouse button.

Double-clicking on the send connection that has been inserted brings up a dialog in which the T=>O Size (outputs, Control-Logix receive data (Consumed must be selected for the corresponding tag), is set.

It is also possible for the Produce Buffer ID to be set, under parameters. This must agree with the instance of the input tag set in the Control-Logix. This Produce Buffer ID is also used for addressing the process data from TwinCAT (-> Process data send connection):

Please refer to the PDF file SstCn_SchCntLgx.pdf for the settings in RS Networx and in RS Logix 5000.

So that the ControlLogix establishes the send connection (the SST card is the producer, Control-Logix the consumer), the scheduling list must be loaded using RS Networx. This requires the network project to be developed offline in RS Networx and then downloaded. If it does not work, the PC should be rebooted and the procedure repeated.

Network Configuration

Double-clicking on network configuration allows the NUT interval and the maximum scheduled and unscheduled Mac-IDs to be set.

Saving the Configuration on the 5136-CN PC Card

By clicking on the scanner in the right hand window with the right mouse button, a pop-up menu appears, with which the current ControlNet configuration is saved on the 5136-CN PC card under "Send Config through SST CN Card".


Overview

The various ControlNet services are represented through ADS-Read and ADS-Write. The Net-ID of the PC is to be given as the Net-ID, with 16000 as the port number. In the IndexGroup, the Mac-ID that is to be addressed (or the Produce Buffer-ID in the case of send connections (e.g. to a PLC5 or ControlLogix)) is to be given, along with the desired data. The IndexOffset specifies the offset within the data.

IndexGroup | Data
0x000000yy | Process data I/O or receive connection (yy: Mac-ID)
0x000100yy | Process data send connection (yy: Produce Buffer ID)
0x000001yy | ID_Object (Read only, yy: Mac-ID)
0x000002yy | Diagnostic_Counter (Read only, yy: Mac-ID)
0x000003yy | Keeper_Info (Read only, yy: Mac-ID)
0x00000400 | CCO_Directory (Read only)
0x00000500 | Card_State (Read only)

If a 5136CN card is not found, the ADS-Error-Code 0x70C (Files, etc. not found) is returned. In the NT System32 directory there are also debug files named "sststartup.txt", "sstcyclic.txt" and "sstshutdown.txt". The last two only contain data after the TwinCAT system has been halted.


Process Data

If the scanner is not yet in its RUN state when process data is accessed (CCO Directory, offset 0x14), error code 0x0708 (Device not ready) is returned.

I/O Connection

An I/O connection is established to ControlNet adapters (e.g. BK7000, AB-Flex-I/O).

Receive Data (ADS Read Response)

Offset | Attributes
0x00 | General status (0: ok, 1: error (Status of the connection)
0x01 | reserved
0x02 | Extended Status (0: ok, > 0: error (Status of the connection)
0x04 | Update counter (is incremented by the sender whenever new data is transmitted)
0x06 | Adapter status (is transmitted)
0x0A | Input data (see device description)

Send Data (ADS Write Request)

Offset | Attributes
0x00 | Scanner status (is transmitted)
0x04 | Output data (see device description)

Receive Connection

A receive connection is established to other ControlNet scanners (e.g. ControlLogix, PLC5).

Receive Data (ADS Read Response)

Offset | Attributes
0x00 | General status (0: ok, 1: error (Status of the connection)
0x01 | reserved
0x02 | Extended Status (0: ok, > 0: error (Status of the connection)
0x04 | Update counter (is incremented by the sender whenever new data is transmitted)
0x06 | Input data (see device description)

Send Connection

A send connection is established to other ControlNet scanners (e.g. ControlLogix, PLC5).

Send Data (ADS Write Request)

Offset | Attributes
0x00 | Output data

Receive Data (ADS Read Response)

Offset | Attributes
0x00 | General status (0: ok, 1: error (Status of the connection)
0x01 | reserved
0x02 | Extended Status (0: ok, > 0: error (Status of the connection)


ID Object

The following data is returned in the ADS read response when the ID object is read:

Offset | Attributes
0x00 | Vendor-ID
0x02 | Device-Type
0x04 | Product-Code
0x06 | Major-Revision
0x07 | Minor-Revision
0x08 | Status
0x0A | Serial-Number
0x0E | Length of the product name
0x10 | Product-Name


Diagnostic Counter

The following data is returned in the ADS read response when reading the Diagnostic Counter (ControlNet Spec. Part 10, Section 240 "ControlNet Object", Table 10-223, Attribute ID 0x82):

Offset | Attributes
0x00 | Number of Errors in Error-Log
0x02 | Error-Log[8]
0x0A | Good Tx-Counter
0x0D | Good Rx-Counter
0x10 | Framing-errors detected on active selected Channel
0x11 | Framing-errors detected on Channel A
0x12 | Framing-errors detected on Channel B
0x13 | Tx-Abort-Counter
0x14 | LLC transmit underflow and LLC receive overflow
0x15 | no unscheduled time in NUT
0x16 | more scheduled data queued for one NUT than allowed by the SchedMaxFrame-parameter
0x17 | single L_packet-size exceeds SchedMaxFrame-parameter
0x18 | two or more nodes could not agree whose turn it is to transmit
0x19 | Rx-Abort-Counter
0x1A | number of times nothing heard on the network for 8 or more NUTs
0x1B | Duplicate Node-Counter
0x1C | Noise-Hits-Counter
0x1D | Collision-Counter
0x1E | Mac ID of the current moderator node
0x1F | Moderator frames heard from non-lowman nodes
0x20 | rogue events detected
0x21 | MAC frames being heard but no no moderators being heard
0x22 | Reserved


Keeper Info

The following data is returned in the ADS-Read-Response when the Keeper-Info (ControlNet-Spec. Part 10, Section 241) is read:

Offset | Attributes
0x00 | Keeper-State (ControlNet-Spec. Part 10, Section 241, Table 10-229)
0x01 | Reserved
 | Current Network Parameters (ControlNet-Spec. Part 10, Section 241, Table 10-228, Attribute ID 255)
0x02 | NUT-Interval
0x04 | Maximum Scheduled Mac ID
0x05 | Maximum Unscheduled Mac ID
0x06 | Slot-Time
0x07 | Blanking-Time
0x08 | Guard Band Start
0x09 | Guard Band Center
0x0A | Reserved
0x0C | Interval Count Modulus
0x0D | Guard Band Pre-Start
 | current Table Unique Identifier (ControlNet-Spec. Part 10, Section 241, Table 10-228, Attribute ID 258)
0x0E | TUI-Unique ID
0x12 | TUI-Status flag (ControlNet-Spec. Part 10, Section 241, Table 10-231)
0x14 | MAC-Id of the node broadcasting the TUI
0x15 | reserved
0x16 | Vendor-Id of object holding the network resource
0x18 | Serial Number of object holding the network resource
0x1C | Class of object holding the network resource
0x20 | Instance of object holding the network resource


CCO Directory

The following data is returned in the ADS-Read-Response when the CCO directory is read:

Local scanner

Offset | Attributes
0x00 | Revision
0x02 | State (Bit 0: all I/O and scheduled receive connections are ok, Bit 8: all scheduled send messages are ok)
0x04 | Maximum number of instances (127)
0x08 | Number of instances currently configured
0x0C | Implementation defined revision
0x0E | Number of Scanner Instances (O-T)
0x10 | Edit Signature for current CCO configuration
0x14 | Current Scanner State (0: no connections are active,1: the scanner is in Prog-Mode, 2: the scanner is in Run-Mode)
0x16 | Current Adapter State (0: all scheduled send messages are disabled, 1: scheduled sends are enabled)
0x18 | Total size in bytes of all Tx Data
0x1A | Total size in bytes of all Rx Data
0x1C | Next available offset for variable length parameters
0x1E | CCO/Scheduling Object Options (Bit 0: ALLOW_CCO_BREAK_IN_RUN, Bit 1: DISALLOW_CCO_OPEN, Bit 8: ALLOW_SCHED_BREAK_IN_RUN, Bit 9: DISALLOW_SCHED_OPEN, Bit 10: ALLOW_SCHED_REMOTE_SET_PROG)
0x20 | Schedule Object Connection Originator Password
0x24 | Flags Indicating various CCO conditions (Bit 0: CCO_FLAG_RES_HELD)
0x26 | Size of Implementation Defined Attribute (in bytes)
0x28 | Scanner Global User Handle
0x2C | Adapter Global User Handle

Remote scanner

Offset | Attributes
0x00 | Revision
0x02 | Maximum number of instances (127)
0x06 | Number of instances currently configured
0x0A | Format number
0x0C | Edit Signature for current CCO configuration


Card State

The following data is returned in the ADS-Read-Response when the status of the CN card is read (values that are OK are printed bold):

Offset | Attributes
0x00 | Card-State: OFFLINE (0x41), ONLINE (0x42), FATAL ERROR (0xE1)
0x02 | NAM-State: GO_OFFLINE (0x00), BAD (0x01), WAIT_FOR_OFFLINE (0x02), GO_ONLINE (0x03), CHK_FOR_CABLE (0x04), WAIT_TO_ROGUE (0x05), WAIT_FOR_ONLINE (0x06), SEND_ALIVE (0x07), WATCH (0x08), LISTEN (0x09), ATTACHED (0x0C)
0x04 | Reserved


Status of the Connection

When the process data is read, the status of the connection (both the General Status and the Extended Status) are returned in the first four bytes. The following values are possible here (in accordance with the ControlNet specification V2.0, Section 4.4):

General Status | Extended Status | Meaning
0x00 |  | Connection established, everything OK
0x01 | 0x0100 | Connection already established
0x01 | 0x0103 | Transport Class and trigger combination is not supported
0x01 | 0x0106 | Owner conflict (e.g. if an attempt is made to use a second connection to access the outputs of the first)
0x01 | 0x0107 | Connection not present
0x01 | 0x0108 | Invalid Connection type
0x01 | 0x0109 | Incorrect Connection Size
0x01 | 0x0110 | Device not ready
0x01 | 0x0111 | RPI supervision is not supported
0x01 | 0x0113 | Maximum number of connections has been reached
0x01 | 0x0114 | Vendor ID or Product Code in the Electronic Key do not agree
0x01 | 0x0115 | Product type in the Electronic Key is not consistent
0x01 | 0x0116 | Major or minor revision in the Electronic Key is not consistent
0x01 | 0x0117 | Invalid Connection Point
0x01 | 0x0118 | Invalid configuration format
0x01 | 0x0119 | No Control connection available
0x01 | 0x011A | No further connection in the device's application
0x01 | 0x0203 | Connection monitoring has activated, so connections can not be made
0x01 | 0x0204 | Timeout during Unconnected Send
0x01 | 0x0205 | Parameter error during Unconnected Send
0x01 | 0x0206 | Data is too long for Unconnected Send
0x01 | 0x0301 | No more memory available
0x01 | 0x0302 | Network bandwidth not sufficient for this connection's data
0x01 | 0x0303 | Screener no longer available
0x01 | 0x0304 | Device can not send real time data
0x01 | 0x0311 | Port in the Path Segment is not available
0x01 | 0x0312 | Link address in the Path Segment is not available
0x01 | 0x0315 | Incorrect segment type or segment value in the Path
0x01 | 0x0316 | Path and Connection not consistent when closing the connection
0x01 | 0x0317 | Segment not present, or Encoded Value in the Network Segment is invalid (usually disappears after TwinCAT is restarted)
0x01 | 0x0318 | Link address that points to the device itself is invalid
0x01 | 0x0319 | Second Resource in a redundant system is not available
0x10 | 0x0206 | Occurs in a Consumer connection to Control-Logix if the network project was not yet developed with RS Networx